--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows Enchanting Reagents.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_RESENCHM"
local arkhana = 0
local startArkhana = 0

local leylightShard = 0
local startLeylight = 0

local chaosCrystal = 0
local startChaos = 0
-----------------------------------------------
local function getArkhana()
	return GetItemCount(124440, true) or 0
end
-----------------------------------------------
local function getLeylight()
	return GetItemCount(124441, true) or 0
end
-----------------------------------------------
local function getChaos()
	return GetItemCount(124442, true) or 0
end
-----------------------------------------------
local function GetButtonText(self, id)
	local arkhanaText
	if not arkhana then
		arkhanaText = "  |TInterface\\Icons\\inv_enchanting_70_arkhana:0|t "..TitanUtils_GetHighlightText("0")
	else
		arkhanaText = "  |TInterface\\Icons\\inv_enchanting_70_arkhana:0|t "..TitanUtils_GetHighlightText(arkhana)
	end

	local leylightText
	if not leylightShard then
		leylightText = "  |TInterface\\Icons\\inv_enchanting_70_leylightcrystal:0|t "..TitanUtils_GetHighlightText("0")
	else
		leylightText = "  |TInterface\\Icons\\inv_enchanting_70_leylightcrystal:0|t "..TitanUtils_GetHighlightText(leylightShard)
	end

	local chaosText
	if not chaosCrystal then
		chaosText = "  |TInterface\\Icons\\inv_enchanting_70_chaosshard:0|t "..TitanUtils_GetHighlightText("0")
	else
		chaosText = "  |TInterface\\Icons\\inv_enchanting_70_chaosshard:0|t "..TitanUtils_GetHighlightText(chaosCrystal)
	end

	local barBalanceArkhana = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (arkhana - startArkhana) > 0 then
			barBalanceArkhana = " |cFF69FF69["..(arkhana - startArkhana).."]"
		elseif (arkhana - startArkhana) < 0 then
			barBalanceArkhana = " |cFFFF2e2e["..(arkhana - startArkhana).."]"
		end
	end

	local barBalanceLeylight = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (leylightShard - startLeylight) > 0 then
			barBalanceLeylight = " |cFF69FF69["..(leylightShard - startLeylight).."]"
		elseif (leylightShard - startLeylight) < 0 then
			barBalanceLeylight = " |cFFFF2e2e["..(leylightShard - startLeylight).."]"
		end
	end

	local barBalanceChaos = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (chaosCrystal - startChaos) > 0 then
			barBalanceChaos = " |cFF69FF69["..(chaosCrystal - startChaos).."]"
		elseif (chaosCrystal - startChaos) < 0 then
			barBalanceChaos = " |cFFFF2e2e["..(chaosCrystal - startChaos).."]"
		end
	end

	return arkhanaText..barBalanceArkhana.." "..leylightText..barBalanceLeylight.." "..chaosText..barBalanceChaos
end
-----------------------------------------------
local function GetTooltipText(self, id)

	local arkhanaBag = "\r"..L["arkhana"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124440)).."\r"
	local arkhanaBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124440, true) - GetItemCount(124440))

	local leylightBag = L["leylight"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124441)).."\r"
	local leylightBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124441, true) - GetItemCount(124441))

	local chaosBag = L["chaosCrystal"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124442)).."\r"
	local chaosBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124442, true) - GetItemCount(124442))

	local valueText = "" -- Difere com e sem reagente
	if arkhana == 0 and chaosCrystal == 0 and chaosCrystal == 0 then
		valueText = "\r"..L["info"].."\r|cFFFF2e2e"..L["noreagent"]
	else
		valueText = "\r"..L["info"]..arkhanaBag..arkhanaBank.."\r\r"..leylightBag..leylightBank.."\r\r"..chaosBag..chaosBank
	end

	return valueText
end
-----------------------------------------------
local eventsTable = {
	PLAYER_ENTERING_WORLD = function(self)
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self.PLAYER_ENTERING_WORLD = nil

		startArkhana = getArkhana()
		arkhana = startArkhana

		startLeylight = getLeylight()
		leylightShard = startLeylight

		startChaos = getChaos()
		chaosCrystal = startChaos

		TitanPanelButton_UpdateButton(self.registry.id)

		self.BAG_UPDATE = function(self, bagID)
			local arkh = getArkhana()
			local leyl = getLeylight()
			local chao = getChaos()
			if arkhana == arkh and leylightShard == leyl and chaosCrystal == chao then return end

			leylightShard = leyl
			arkhana = arkh
			chaosCrystal = chao
			TitanPanelButton_UpdateButton(self.registry.id)
		end
		self:RegisterEvent("BAG_UPDATE")
	end
}
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFEC7A37 "..L["enchanting"].."|r [|cFFEC7A37"..L["reagents"].."|r] Multi",
	tooltip = L["enchanting"].."|r [|cFFEC7A37"..L["reagents"].."|r]",
	icon = "Interface\\Icons\\Trade_engraving",
	category = "Profession",
	version = version.."beta",
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareReagentsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	},
	eventsTable = eventsTable
})
