--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows Herbalism Reagents.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_RESHERBM"
local yserallineSeed = 0
local startYseralline = 0

local felwort = 0
local startFelwort = 0

local starlightRose = 0
local startStarlight = 0

local fjarnskaggl = 0
local startFjarnskaggl = 0

local foxflower = 0
local startFox = 0

local dreamleaf = 0
local startDreamleaf = 0

local aethril = 0
local startAethril = 0
-----------------------------------------------
local function getYseralline()
	return GetItemCount(128304, true) or 0
end
-----------------------------------------------
local function getFelwort()
	return GetItemCount(124106, true) or 0
end
-----------------------------------------------
local function getStarlight()
	return GetItemCount(124105, true) or 0
end
-----------------------------------------------
local function getFjarnskaggl()
	return GetItemCount(124104, true) or 0
end
-----------------------------------------------
local function getFoxFlower()
	return GetItemCount(124103, true) or 0
end
-----------------------------------------------
local function getDreamleaf()
	return GetItemCount(124102, true) or 0
end
-----------------------------------------------
local function getAethril()
	return GetItemCount(124101, true) or 0
end
-----------------------------------------------
local function GetButtonText(self, id)
	local yserallineText
	if not yserallineSeed then
		yserallineText = "  |TInterface\\Icons\\inv_herbalism_70_yserallineseed:0|t "..TitanUtils_GetHighlightText("0")
	else
		yserallineText = "  |TInterface\\Icons\\inv_herbalism_70_yserallineseed:0|t "..TitanUtils_GetHighlightText(yserallineSeed)
	end

	local felwortText
	if not felwort then
		felwortText = "  |TInterface\\Icons\\inv_herbalism_70_felwort:0|t "..TitanUtils_GetHighlightText("0")
	else
		felwortText = "  |TInterface\\Icons\\inv_herbalism_70_felwort:0|t "..TitanUtils_GetHighlightText(felwort)
	end

	local starlightText
	if not starlightRose then
		starlightText = "  |TInterface\\Icons\\inv_herbalism_70_starlightrosepetals:0|t "..TitanUtils_GetHighlightText("0")
	else
		starlightText = "  |TInterface\\Icons\\inv_herbalism_70_starlightrosepetals:0|t "..TitanUtils_GetHighlightText(starlightRose)
	end

	local fjarnskagglText
	if not fjarnskaggl then
		fjarnskagglText = "  |TInterface\\Icons\\inv_herbalism_70_fjarnskaggl:0|t "..TitanUtils_GetHighlightText("0")
	else
		fjarnskagglText = "  |TInterface\\Icons\\inv_herbalism_70_fjarnskaggl:0|t "..TitanUtils_GetHighlightText(fjarnskaggl)
	end

	local foxFlowerText
	if not foxflower then
		foxFlowerText = "  |TInterface\\Icons\\inv_herbalism_70_foxflower:0|t "..TitanUtils_GetHighlightText("0")
	else
		foxFlowerText = "  |TInterface\\Icons\\inv_herbalism_70_foxflower:0|t "..TitanUtils_GetHighlightText(foxflower)
	end

	local dreamleafText
	if not dreamleaf then
		dreamleafText = "  |TInterface\\Icons\\inv_herbalism_70_dreamleaf:0|t "..TitanUtils_GetHighlightText("0")
	else
		dreamleafText = "  |TInterface\\Icons\\inv_herbalism_70_dreamleaf:0|t "..TitanUtils_GetHighlightText(dreamleaf)
	end

	local aethrilText
	if not aethril then
		aethrilText = "  |TInterface\\Icons\\inv_herbalism_70_aethril:0|t "..TitanUtils_GetHighlightText("0")
	else
		aethrilText = "  |TInterface\\Icons\\inv_herbalism_70_aethril:0|t "..TitanUtils_GetHighlightText(aethril)
	end

	local barBalanceYseralline = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (yserallineSeed - startYseralline) > 0 then
			barBalanceYseralline = " |cFF69FF69["..(yserallineSeed - startYseralline).."]"
		elseif (yserallineSeed - startYseralline) < 0 then
			barBalanceYseralline = " |cFFFF2e2e["..(yserallineSeed - startYseralline).."]"
		end
	end

	local barBalanceFelwort = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (felwort - startFelwort) > 0 then
			barBalanceFelwort = " |cFF69FF69["..(felwort - startFelwort).."]"
		elseif (felwort - startFelwort) < 0 then
			barBalanceFelwort = " |cFFFF2e2e["..(felwort - startFelwort).."]"
		end
	end

	local barBalanceStarlight = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (starlightRose - startStarlight) > 0 then
			barBalanceStarlight = " |cFF69FF69["..(starlightRose - startStarlight).."]"
		elseif (starlightRose - startStarlight) < 0 then
			barBalanceStarlight = " |cFFFF2e2e["..(starlightRose - startStarlight).."]"
		end
	end

	local barBalanceFjarnskaggl = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (fjarnskaggl - startFjarnskaggl) > 0 then
			barBalanceFjarnskaggl = " |cFF69FF69["..(fjarnskaggl - startFjarnskaggl).."]"
		elseif (fjarnskaggl - startFjarnskaggl) < 0 then
			barBalanceFjarnskaggl = " |cFFFF2e2e["..(fjarnskaggl - startFjarnskaggl).."]"
		end
	end

	local barBalanceStartFox = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (foxflower - startFox) > 0 then
			barBalanceStartFox = " |cFF69FF69["..(foxflower - startFox).."]"
		elseif (foxflower - startFox) < 0 then
			barBalanceStartFox = " |cFFFF2e2e["..(foxflower - startFox).."]"
		end
	end

	local barBalanceDreamleaf = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (dreamleaf - startDreamleaf) > 0 then
			barBalanceDreamleaf = " |cFF69FF69["..(dreamleaf - startDreamleaf).."]"
		elseif (dreamleaf - startDreamleaf) < 0 then
			barBalanceDreamleaf = " |cFFFF2e2e["..(dreamleaf - startDreamleaf).."]"
		end
	end

	local barBalanceAethril = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (aethril - startAethril) > 0 then
			barBalanceAethril = " |cFF69FF69["..(aethril - startAethril).."]"
		elseif (aethril - startAethril) < 0 then
			barBalanceAethril = " |cFFFF2e2e["..(aethril - startAethril).."]"
		end
	end

	return yserallineText..barBalanceYseralline.." "..felwortText..barBalanceFelwort.." "..starlightText..barBalanceStarlight..fjarnskagglText..barBalanceFjarnskaggl.." "..foxFlowerText..barBalanceStartFox.." "..dreamleafText..barBalanceDreamleaf.." "..aethrilText..barBalanceAethril
end
-----------------------------------------------
local function GetTooltipText(self, id)

	local yserallineBag = "\r"..L["yseralline"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(128304)).."\r"
	local yserallineBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(128304, true) - GetItemCount(128304))

	local felwortBag = L["felwort"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124106)).."\r"
	local felwortBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124106, true) - GetItemCount(124106))

	local starlightBag = L["starlight"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124105)).."\r"
	local starlightBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124105, true) - GetItemCount(124105))

	local fjarnskagglBag = L["fjarn"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124104)).."\r"
	local fjarnskagglBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124104, true) - GetItemCount(124104))

	local foxFlowerBag = L["foxflower"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124103)).."\r"
	local foxFlowerBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124103, true) - GetItemCount(124103))

	local dreamleafBag = L["dreamleaf"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124102)).."\r"
	local dreamleafBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124102, true) - GetItemCount(124102))

	local aethrilBag = L["aethril"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(124101)).."\r"
	local aethrilBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(124101, true) - GetItemCount(124101))

	local valueText = "" -- Difere com e sem reagente
	if yserallineSeed == 0 and felwort == 0 and starlightRose == 0 and fjarnskaggl == 0 and foxflower == 0 and dreamleaf == 0 and aethril == 0 then
		valueText = "\r"..L["info"].."\r|cFFFF2e2e"..L["noreagent"]
	else
		valueText = "\r"..L["info"]..yserallineBag..yserallineBank.."\r\r"..felwortBag..felwortBank.."\r\r"..starlightBag..starlightBank.."\r\r"..fjarnskagglBag..fjarnskagglBank.."\r\r"..foxFlowerBag..foxFlowerBank.."\r\r"..dreamleafBag..dreamleafBank.."\r\r"..aethrilBag..aethrilBank
	end

	return valueText
end
-----------------------------------------------
local eventsTable = {
	PLAYER_ENTERING_WORLD = function(self)
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self.PLAYER_ENTERING_WORLD = nil

		startYseralline = getYseralline()
		yserallineSeed = startYseralline

		startFelwort = getFelwort()
		felwort = startFelwort

		startStarlight = getStarlight()
		starlightRose = startStarlight

		startFjarnskaggl = getFjarnskaggl()
		fjarnskaggl = startFjarnskaggl

		startFox = getFoxFlower()
		foxflower = startFox

		startDreamleaf = getDreamleaf()
		dreamleaf = startDreamleaf

		startAethril = getAethril()
		aethril = startAethril

		TitanPanelButton_UpdateButton(self.registry.id)

		self.BAG_UPDATE = function(self, bagID)
			local yser = getYseralline()
			local felw = getFelwort()
			local slig = getStarlight()
			local fjar = getFjarnskaggl()
			local fflw = getFoxFlower()
			local drl = getDreamleaf()
			local aeth = getAethril()
			if yserallineSeed == yser and felwort == felw and starlightRose == slig and fjarnskaggl == fjar and foxflower == fflw and dreamleaf == drl and aethril == aeth then return end

			yserallineSeed = yser
			felwort = felw
			starlightRose = slig
			fjarnskaggl = fjar
			foxflower = fflw
			dreamleaf = drl
			aethril = aeth
			TitanPanelButton_UpdateButton(self.registry.id)
		end
		self:RegisterEvent("BAG_UPDATE")
	end
}
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFEC7A37 "..L["herbalism"].."|r [|cFFEC7A37"..L["reagents"].."|r] Multi",
	tooltip = L["herbalism"].."|r [|cFFEC7A37"..L["reagents"].."|r]",
	icon = "Interface\\Icons\\Trade_herbalism",
	category = "Profession",
	version = version.."beta",
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareReagentsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	},
	eventsTable = eventsTable
})
